// Jrn Loviscach, 2001-06-19

package java3ddemo;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class JavaThreeDee
{
  public static void main( String[] args )
  {
    new JavaThreeDee();
  }

  public JavaThreeDee()
  {
    BranchGroup root = new BranchGroup();

    // Baumstruktur:
    // root --> t1 --> t2 --> s (Appearance --> Material)
    TransformGroup t1 = new TransformGroup();
    // ntig, um darin etwas verstellen oder animieren zu knnen:
    t1.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    root.addChild(t1);
    TransformGroup t2 = new TransformGroup();
    Transform3D pos = new Transform3D();
    pos.setTranslation(new Vector3f(0.5f,0.0f,0.0f));
    t2.setTransform(pos);
    t1.addChild(t2);
    Appearance a = new Appearance();
    Material m = new Material();
    m.setDiffuseColor(1.0f, 0.0f, 0.0f);
    m.setAmbientColor(0.3f, 0.3f, 0.0f);
    m.setShininess(8.0f);
    a.setMaterial(m);
    Sphere s = new Sphere(0.1f, a);
    t2.addChild(s);

    // Alpha macht hier einen Sgezahn mit Periode 5000 (= 5 Sekunden).
    Alpha rotationAlpha = new Alpha(-1, 5000);
    Transform3D yAxis = new Transform3D();
    // Animation:
    RotationInterpolator rotator =
        new RotationInterpolator(
            rotationAlpha, t1, yAxis, 0.0f, (float) Math.PI*2.0f);
    // Interpolator wirkt auf alles in diesem riesigen Volumen:
    BoundingSphere b = new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000.0);
    rotator.setSchedulingBounds(b);
    root.addChild(rotator);

    Color3f lightColor = new Color3f(1.0f, 1.0f, 1.0f);
    Vector3f lightDirection = new Vector3f(1.0f, -1.0f, -1.0f);
    DirectionalLight light = new DirectionalLight(lightColor, lightDirection);
    // Licht wirkt auf alles in diesem riesigen Volumen:
    light.setInfluencingBounds(b);
    root.addChild(light);

    Color3f ambientColor = new Color3f(0.7f, 0.7f, 0.7f);
    AmbientLight ambientLightNode = new AmbientLight(ambientColor);
    // Licht wirkt auf alles in diesem riesigen Volumen:
    ambientLightNode.setInfluencingBounds(b);
    root.addChild(ambientLightNode);

    JFrame f = new JFrame("Java3D-Demo");
    Canvas3D c = new Canvas3D(null);
    f.getContentPane().add(c);

    SimpleUniverse u = new SimpleUniverse(c);
    u.getViewingPlatform().setNominalViewingTransform();
    u.addBranchGraph(root);

    f.addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){System.exit(0);}});
    f.setSize(200, 200);
    f.setLocation(50, 50);
    f.show();
  }
}